/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/*                       FILE POINTER VARIABLES.
*******************************************************************************/
FILE *fp1,*fp2;                                             /* File pointers. */
/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
long Sym_Cnt;                                                /* Symbol count. */
long Valid_Sym;                                        /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
int Inp_Sym_Num;                                /* Sym. no. i/p to conv. enc. */
int Op_Sym_Num;                               /* Sym. no. o/p from conv. enc. */
int P_State;                                     /* Present state of encoder. */
double Re_Sym;                                 /* Re. part of current symbol. */
double Im_Sym;                                 /* Im. part of current symbol. */
double Re_Map[CONSTELL_SIZE];                         /* Re. part of symbols. */
double Im_Map[CONSTELL_SIZE];                         /* Im. part of symbols. */
/******************************************************************************/
/*                    VARIABLES RELATED TO ERROR BUFFER.
*******************************************************************************/
int Err_Cnt;                                      /* No. of symbols in error. */
int Err_Buf_Inx;                                    /* Index to error buffer. */
int Err_Buf[ERR_BUF_SIZE];                                   /* Error buffer. */
/******************************************************************************/
/*                           CHANNEL VARIABLES.
*******************************************************************************/
double Chan_Energy;                                        /* Channel energy. */
double Re_Chan_Op;                                     /* Re. channel output. */
double Im_Chan_Op;                                     /* Im. channel output. */
double Re_Chan_Tap[CHAN_SIZE];                           /* Re. channel taps. */
double Im_Chan_Tap[CHAN_SIZE];                           /* Im. channel taps. */
double Re_Chan_Reg[CHAN_SIZE];                            /* Re. channel reg. */
double Im_Chan_Reg[CHAN_SIZE];                            /* Im. channel reg. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
double N_Val[NVALSIZE];                          /* Contains U & G rand. var. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Tx_Trel_NS[NUM_TX_STATES][NUM_INPUTS];         /* Tx. trellis:Next state. */
int Tx_Trel_Op[NUM_TX_STATES][NUM_INPUTS];                 /* Tx. trellis:Op. */
int Rx_Trel_NS[NUM_RX_STATES][NUM_INPUTS];         /* Rx. trellis:Next state. */
double Re_Rx_Trel_Op[NUM_RX_STATES][NUM_INPUTS];                   /* Re. op. */
double Im_Rx_Trel_Op[NUM_RX_STATES][NUM_INPUTS];                   /* Im. op. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE VITERBI.
*******************************************************************************/
int Depth;                              /* Gives the current depth of the VA. */
int VA_Inp;                                      /* Current input to a state. */
int VA_P_St;                                                /* Current state. */
int VA_N_St;                                                   /* Next state. */
int Min_Wght_St;                          /* State having the maximum weight. */
int VA_Ip_Sym_Num;                              /* Ip. symbol released by VA. */
int VA_Op_Sym_Num;                              /* Op. symbol released by VA. */
int VA_Op_Buf_Inx;                              /* Index to VA output buffer. */
int VA_Op_Buf[ERR_BUF_SIZE];            /* Buffer to store VA output symbols. */
double Cur_Wght;                                            /* Cur. distance. */
double New_Wght;                                             /* New net wght. */
double Old_Wght;                                             /* Old net wght. */
struct Trellis *Fst_Depth,*Lst_Depth;                           /* Templates. */
/******************************************************************************/
