/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "n2type.h"
#include "n2ext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Enc_Init();
 Err_Buf_Init();
 Error_Init();
 Noise_Gen_Init();
 VA_Init();
 return(0);
}
/******************************************************************************/
/*                         Initialize the encoder.
*******************************************************************************/
int Enc_Init()
{
 P_State=ZERO;
 return(0);
}
/******************************************************************************/
/*                      Initialize the error buffer.
*******************************************************************************/
int Err_Buf_Init()
{
 Err_Buf_Inx=ZERO;
 return(0);
}
/******************************************************************************/
/*                       Initialize the error.
*******************************************************************************/
int Error_Init()
{
 Err_Cnt=ZERO;
 Valid_Sym=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 long int random(void);
 N1_Store[0]=(unsigned short)random();
 N1_Store[1]=(unsigned short)random();
 N1_Store[2]=(unsigned short)random();
 N2_Store[0]=(unsigned short)random();
 N2_Store[1]=(unsigned short)random();
 N2_Store[2]=(unsigned short)random();
 return(0);
}
/******************************************************************************/
/*                            Initialize the VA.
*******************************************************************************/
int VA_Init()
{
 Depth=ZERO;
 Fst_Depth=Lst_Depth=NULL;
 VA_Ip_Sym_Num=VA_Op_Sym_Num= MINUSONE;
 VA_Op_Buf_Inx=ZERO;
 Min_Wght_St=ZERO;
 return(0);
}
/******************************************************************************/
