/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "n3type.h"
#include "n3ext.h"
/******************************************************************************/
int Simulation()
{
 for(Sym_Cnt=ZERO;Sym_Cnt<MAX_SYM;Sym_Cnt++)
 {
  Get_Symbol();
  Get_Channel_Output();
  Add_Noise();
  Receive();
 }
 return(0);
}
/******************************************************************************/
/*                        Get the channel output.
*******************************************************************************/
int Get_Channel_Output()
{
 int cnt;
 Shift_Right(Re_Chan_Reg,Im_Chan_Reg,CHAN_SIZE);
 Re_Chan_Reg[ZERO]=Re_Sym;
 Im_Chan_Reg[ZERO]=Im_Sym;
 Re_Chan_Op=Im_Chan_Op=0.0;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
 {
  Re_Chan_Op=Re_Chan_Op+Re_Chan_Reg[cnt]*Re_Chan_Tap[cnt];
  Re_Chan_Op=Re_Chan_Op-Im_Chan_Reg[cnt]*Im_Chan_Tap[cnt];
  Im_Chan_Op=Im_Chan_Op+Re_Chan_Reg[cnt]*Im_Chan_Tap[cnt];
  Im_Chan_Op=Im_Chan_Op+Im_Chan_Reg[cnt]*Re_Chan_Tap[cnt];
 }
 return(0);
}
/******************************************************************************/
/*                        Add white Gaussian noise.
*******************************************************************************/
int Add_Noise()
{
 double erand48();
 N_Val[URADIUS]=erand48(N1_Store);
 N_Val[UTHETA]=erand48(N2_Store);
 My_Gauss(VARIANCE,N_Val);
 Re_Chan_Op=Re_Chan_Op+N_Val[GRAND_0];
 Im_Chan_Op=Im_Chan_Op+N_Val[GRAND_1];
 return(0);
}
/******************************************************************************/
/*                         Receiver routines.
*******************************************************************************/
int Receive()
{
 if(Sym_Cnt >= CHAN_SIZE)
  Viterbi();
 if(Sym_Cnt >= ERR_BUF_SHIFT_OUT_START)
  Update_Error();
 return(0);
}
/******************************************************************************/
/*                     Update the symbol error count.
*******************************************************************************/
int Update_Error()
{
 int cnt,inx;
 inx=CHAN_SIZE;
// if(Sym_Cnt > 900)
//  printf("cnt:%d ebuf:%d va:%d\n",Sym_Cnt,Err_Buf[inx],VA_Ip_Sym_Num);
 if(Err_Buf[inx] != VA_Ip_Sym_Num)
  Err_Cnt++;
 Valid_Sym++;
 for(cnt=ZERO;cnt<=(Err_Buf_Inx-2);cnt++)
  Err_Buf[cnt]=Err_Buf[cnt+ONE];
 Err_Buf_Inx--;
 if(Err_Buf_Inx < ZERO)
  Error_Mes(7);
 return(0);
}
/******************************************************************************/
