#*******************************************************************************
#    Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plots of symbol error rate of predictive and regular VA in white and
# coloured noise.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "pc1ber.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "pc1ber.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
#set term postscript eps color 22
#set key outside below title 'Legend' box 3
set key right bottom box
set grid xtics ytics mytics
set format y "%2.1e"
#set output "pc1ber.eps"
set logscale y
#set xlabel "SNR (dB)"
#set ylabel "Symbol error rate"
plot "pc1white.dat" t "CVA in white noise" w lines lt 1 lw 3,\
     "pc1p8.dat" t "CVA in coloured noise" w lines lt 3 lw 3,\
     "../../pc2/pc2data/pc2p8.dat" t "PVA in coloured noise" w lines\
     lt 4 lw 3,\
     "../../pc2/pc2data/pc2p8az.dat" t "PVA in coloured noise all 0" w lines\
     lt 5 lw 3,\
     "../../pctheory/pvacoded.dat"\
      t "PVA coloured noise-lower bound all 0" w lines\
     lt 6 lw 3,\
     "../../pctheory/cvacoded.dat"\
      t "CVA coloured noise-lower bound" w lines\
     lt 7 lw 3
