/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc10type.h"
#include "pc10ext.h"
/******************************************************************************/
/*                      Update the predictor coefficients.
*******************************************************************************/
int DD_Pred_Update()
{
 Get_Pred_Error();
 Get_New_Pred_Coeff();
 return(0);
}
/******************************************************************************/
/*                     Get the prediction filter error.
*******************************************************************************/
int Get_Pred_Error()
{
 int op,cnt,inx;
 double re_err,im_err,re_cf,im_cf;
 op=VA_Op_Reg[ZERO];
 inx=VA_DEPTH-ONE;
 Re_Pred_Err=Re_Eq_Op_Reg[inx]-Re_Map[op];
 Im_Pred_Err=Im_Eq_Op_Reg[inx]-Im_Map[op];
 Pred_Err_Energy=Re_Pred_Err*Re_Pred_Err+Im_Pred_Err*Im_Pred_Err;
 for(cnt=ONE;cnt<=PRED_MEM_SIZE;cnt++)
 {
  op=VA_Op_Reg[cnt];
  re_err=Re_Eq_Op_Reg[cnt+inx]-Re_Map[op];
  im_err=Im_Eq_Op_Reg[cnt+inx]-Im_Map[op];
  re_cf=Re_Pred_Coeff[PRED_MEM_SIZE][cnt];
  im_cf=Im_Pred_Coeff[PRED_MEM_SIZE][cnt];
  Pred_Err_Energy=Pred_Err_Energy+re_err*re_err+im_err*im_err;
  Re_Pred_Err=Re_Pred_Err+re_err*re_cf-im_err*im_cf;
  Im_Pred_Err=Im_Pred_Err+re_err*im_cf+im_err*re_cf;
 }
 return(0);
}
/******************************************************************************/
/*               Get the new prediction filter coefficients.
*******************************************************************************/
int Get_New_Pred_Coeff()
{
 int cnt,inx,op;
 double re_grad,im_grad,ss_fac,re_err,im_err;
 inx=VA_DEPTH-ONE;
 ss_fac=0.01;
 for(cnt=ONE;cnt<=PRED_MEM_SIZE;cnt++)
 {
  op=VA_Op_Reg[cnt];
  re_err=Re_Eq_Op_Reg[cnt+inx]-Re_Map[op];
  im_err=Im_Eq_Op_Reg[cnt+inx]-Im_Map[op];
  re_grad=Re_Pred_Err*re_err+Im_Pred_Err*im_err;
  im_grad=Im_Pred_Err*re_err-Re_Pred_Err*im_err;
  re_grad=ss_fac*EQ_STEP*re_grad/Pred_Err_Energy;
  im_grad=ss_fac*EQ_STEP*im_grad/Pred_Err_Energy;
  Re_Pred_Coeff[PRED_MEM_SIZE][cnt]=Re_Pred_Coeff[PRED_MEM_SIZE][cnt]-re_grad;
  Im_Pred_Coeff[PRED_MEM_SIZE][cnt]=Im_Pred_Coeff[PRED_MEM_SIZE][cnt]-im_grad;
 }
 return(0);
}
/******************************************************************************/
