/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/*                       FILE POINTER VARIABLES.
*******************************************************************************/
extern FILE *fp1,*fp2,*fp3,*fp6,*fp7;                       /* File pointers. */
/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern int Samp_Cnt;                                         /* Sample count. */
extern long Sym_Cnt;                                         /* Symbol count. */
extern long Valid_Sym;                                 /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
extern int Inp_Sym_Num;                         /* Sym. no. i/p to conv. enc. */
extern int Op_Sym_Num;                        /* Sym. no. o/p from conv. enc. */
extern int P_State;                              /* Present state of encoder. */
extern double Re_Sym;                          /* Re. part of current symbol. */
extern double Im_Sym;                          /* Im. part of current symbol. */
extern double Re_Map[CONSTELL_SIZE];                  /* Re. part of symbols. */
extern double Im_Map[CONSTELL_SIZE];                  /* Im. part of symbols. */
/******************************************************************************/
/*                    VARIABLES RELATED TO ERROR BUFFER.
*******************************************************************************/
extern int Err_Cnt;                               /* No. of symbols in error. */
extern int Err_Buf_Inx;                             /* Index to error buffer. */
extern int Err_Buf[ERR_BUF_SIZE];                            /* Error buffer. */
/******************************************************************************/
/*                           CHANNEL VARIABLES.
*******************************************************************************/
extern double Chan_Energy;                                 /* Channel energy. */
extern double Re_Chan_Op;                              /* Re. channel output. */
extern double Im_Chan_Op;                              /* Im. channel output. */
extern double Chan_Tap[CHAN_SIZE];                           /* Channel taps. */
extern double F_Chan_Tap[CHAN_SIZE];      /* Channel taps after adding noise. */
extern double Re_Chan_Reg[CHAN_SIZE];                     /* Re. channel reg. */
extern double Im_Chan_Reg[CHAN_SIZE];                     /* Im. channel reg. */
/******************************************************************************/
/*                         FADE FILTER VARIABLES.
*******************************************************************************/
extern int Fade_Samp_Cnt[SAMP_PER_SYM]; /* Count of the interpolation factor. */
extern double Gamma_1b4;                                       /* Gamma(1/4). */
extern double F_Filter[FF_SIZE];                 /* Fade filter coefficients. */
extern double J_b;                                        /* Bessel function. */
extern double Fade_Var;                      /* Variance of the fade process. */
extern double Fade_Reg[CHAN_SIZE][FF_REG_SIZE];   /* Registers to store AWGN. */
extern double Fade_Op[CHAN_SIZE];               /* Contains correlated noise. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double N_Val[NVALSIZE];                   /* Contains U & G rand. var. */
extern double Re_Noise;                        /* Re. part of coloured noise. */
extern double Im_Noise;                        /* Im. part of coloured noise. */
/******************************************************************************/
/*                          EQUALIZER VARIABLES.
*******************************************************************************/
extern int Eq_Err_Buf_Inx;                /* Index to equalizer error buffer. */
extern int Eq_Err_Buf[ERR_BUF_SIZE];               /* Equalizer error buffer. */
extern double Eq_Inp_Energy;                    /* Energy of equalizer input. */
extern double Re_Eq_Err;                       /* Re. error at equalizer o/p. */
extern double Im_Eq_Err;                       /* Im. error at equalizer o/p. */
extern double Re_Eq_Op;                                 /* Re. equalizer o/p. */
extern double Im_Eq_Op;                                 /* Im. equalizer o/p. */
extern double Mod_Re_Eq_Op[NUM_TX_STATES];                /* PSP re. eq. o/p. */
extern double Mod_Im_Eq_Op[NUM_TX_STATES];                /* PSP im. eq. o/p. */
extern double Re_Eq_Tap[EQ_TAP_SIZE];                  /* Re. equalizer taps. */
extern double Im_Eq_Tap[EQ_TAP_SIZE];                  /* Im. equalizer taps. */
extern double Re_Eq_Reg[EQ_REG_SIZE];                   /* Re. equalizer reg. */
extern double Im_Eq_Reg[EQ_REG_SIZE];                   /* Im. equalizer reg. */
extern double Re_Eq_Op_Reg[NUM_TX_STATES][EQ_OP_REG_SIZE];   /* PSP re eq op. */
extern double Im_Eq_Op_Reg[NUM_TX_STATES][EQ_OP_REG_SIZE];   /* PSP im eq op. */
extern double Re_DF_Tap[DF_SIZE];                              /* Re. DF tap. */
extern double Im_DF_Tap[DF_SIZE];                              /* Im. DF tap. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Tx_Trel_NS[NUM_TX_STATES][NUM_INPUTS];              /* Tx:Nxt. st. */
extern int Tx_Trel_Op[NUM_TX_STATES][NUM_INPUTS];                   /* Tx:Op. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE VITERBI.
*******************************************************************************/
extern int Depth;                       /* Gives the current depth of the VA. */
extern int VA_Inp;                               /* Current input to a state. */
extern int VA_P_St;                                         /* Current state. */
extern int VA_N_St;                                            /* Next state. */
extern int Min_Wght_St;                   /* State having the maximum weight. */
extern int VA_Ip_Sym_Num;                       /* Ip. symbol released by VA. */
extern int VA_Op_Sym_Num;                       /* Op. symbol released by VA. */
extern int VA_Decoded_State;                 /* Last state decoded by the VA. */
extern int VA_Op_Reg[VA_OP_REG_SIZE];          /* To store VA output symbols. */
extern double Cur_Wght;                                     /* Cur. distance. */
extern double New_Wght;                                      /* New net wght. */
extern double Old_Wght;                                      /* Old net wght. */
extern struct Trellis *Fst_Depth,*Lst_Depth;                    /* Templates. */
/******************************************************************************/
