/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/*                       FILE POINTER VARIABLES.
*******************************************************************************/
FILE *fp1,*fp2,*fp3,*fp6,*fp7;                              /* File pointers. */
/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
int Samp_Cnt;                                                /* Sample count. */
long Sym_Cnt;                                                /* Symbol count. */
long Valid_Sym;                                        /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
int Inp_Sym_Num;                                /* Sym. no. i/p to conv. enc. */
int Op_Sym_Num;                               /* Sym. no. o/p from conv. enc. */
int P_State;                                     /* Present state of encoder. */
double Re_Sym;                                 /* Re. part of current symbol. */
double Im_Sym;                                 /* Im. part of current symbol. */
double Re_Map[CONSTELL_SIZE];                         /* Re. part of symbols. */
double Im_Map[CONSTELL_SIZE];                         /* Im. part of symbols. */
/******************************************************************************/
/*                    VARIABLES RELATED TO ERROR BUFFER.
*******************************************************************************/
int Err_Cnt;                                      /* No. of symbols in error. */
int Err_Buf_Inx;                                    /* Index to error buffer. */
int Err_Buf[ERR_BUF_SIZE];                                   /* Error buffer. */
/******************************************************************************/
/*                           CHANNEL VARIABLES.
*******************************************************************************/
double Chan_Energy;                                        /* Channel energy. */
double Re_Chan_Op;                                     /* Re. channel output. */
double Im_Chan_Op;                                     /* Im. channel output. */
double Chan_Tap[CHAN_SIZE];                                  /* Channel taps. */
double F_Chan_Tap[CHAN_SIZE];             /* Channel taps after adding noise. */
double Re_Chan_Reg[CHAN_SIZE];                            /* Re. channel reg. */
double Im_Chan_Reg[CHAN_SIZE];                            /* Im. channel reg. */
/******************************************************************************/
/*                         FADE FILTER VARIABLES.
*******************************************************************************/
int Fade_Samp_Cnt[SAMP_PER_SYM];        /* Count of the interpolation factor. */
double Gamma_1b4;                                              /* Gamma(1/4). */
double F_Filter[FF_SIZE];                        /* Fade filter coefficients. */
double J_b;                                               /* Bessel function. */
double Fade_Var;                             /* Variance of the fade process. */
double Fade_Reg[CHAN_SIZE][FF_REG_SIZE];          /* Registers to store AWGN. */
double Fade_Op[CHAN_SIZE];                      /* Contains correlated noise. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
double N_Val[NVALSIZE];                          /* Contains U & G rand. var. */
double Re_Noise;                               /* Re. part of coloured noise. */
double Im_Noise;                               /* Im. part of coloured noise. */
/******************************************************************************/
/*                          EQUALIZER VARIABLES.
*******************************************************************************/
int Eq_Err_Buf_Inx;                       /* Index to equalizer error buffer. */
int Eq_Err_Buf[ERR_BUF_SIZE];                      /* Equalizer error buffer. */
double Eq_Inp_Energy;                           /* Energy of equalizer input. */
double Re_Eq_Err;                              /* Re. error at equalizer o/p. */
double Im_Eq_Err;                              /* Im. error at equalizer o/p. */
double Re_Eq_Op;                                        /* Re. equalizer o/p. */
double Im_Eq_Op;                                        /* Im. equalizer o/p. */
double Mod_Re_Eq_Op[NUM_TX_STATES];                       /* PSP re. eq. o/p. */
double Mod_Im_Eq_Op[NUM_TX_STATES];                       /* PSP im. eq. o/p. */
double Re_Eq_Tap[EQ_TAP_SIZE];                         /* Re. equalizer taps. */
double Im_Eq_Tap[EQ_TAP_SIZE];                         /* Im. equalizer taps. */
double Re_Eq_Reg[EQ_REG_SIZE];                          /* Re. equalizer reg. */
double Im_Eq_Reg[EQ_REG_SIZE];                          /* Im. equalizer reg. */
double Re_Eq_Op_Reg[NUM_TX_STATES][EQ_OP_REG_SIZE];          /* PSP re eq op. */
double Im_Eq_Op_Reg[NUM_TX_STATES][EQ_OP_REG_SIZE];          /* PSP im eq op. */
double Re_DF_Tap[DF_SIZE];                                     /* Re. DF tap. */
double Im_DF_Tap[DF_SIZE];                                     /* Im. DF tap. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Tx_Trel_NS[NUM_TX_STATES][NUM_INPUTS];                     /* Tx:Nxt. st. */
int Tx_Trel_Op[NUM_TX_STATES][NUM_INPUTS];                          /* Tx:Op. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE VITERBI.
*******************************************************************************/
int Depth;                              /* Gives the current depth of the VA. */
int VA_Inp;                                      /* Current input to a state. */
int VA_P_St;                                                /* Current state. */
int VA_N_St;                                                   /* Next state. */
int Min_Wght_St;                          /* State having the maximum weight. */
int VA_Ip_Sym_Num;                              /* Ip. symbol released by VA. */
int VA_Op_Sym_Num;                              /* Op. symbol released by VA. */
int VA_Decoded_State;                        /* Last state decoded by the VA. */
int VA_Op_Reg[VA_OP_REG_SIZE];                 /* To store VA output symbols. */
double Cur_Wght;                                            /* Cur. distance. */
double New_Wght;                                             /* New net wght. */
double Old_Wght;                                             /* Old net wght. */
struct Trellis *Fst_Depth,*Lst_Depth;                           /* Templates. */
/******************************************************************************/
