/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc12type.h"
#include "pc12ext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Enc_Init();
 Err_Buf_Init();
 Error_Init();
 Noise_Gen_Init();
 Eq_Taps_Init();
 Eq_Op_Reg_Init();
 VA_Init();
 return(0);
}
/******************************************************************************/
/*                         Initialize the encoder.
*******************************************************************************/
int Enc_Init()
{
 P_State=ZERO;
 return(0);
}
/******************************************************************************/
/*                      Initialize the error buffer.
*******************************************************************************/
int Err_Buf_Init()
{
 Eq_Err_Buf_Inx=Err_Buf_Inx=ZERO;
 return(0);
}
/******************************************************************************/
/*                       Initialize the error.
*******************************************************************************/
int Error_Init()
{
 Err_Cnt=ZERO;
 Valid_Sym=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 long int random(void);
 N1_Store[0]=(unsigned short)random();
 N1_Store[1]=(unsigned short)random();
 N1_Store[2]=(unsigned short)random();
 N2_Store[0]=(unsigned short)random();
 N2_Store[1]=(unsigned short)random();
 N2_Store[2]=(unsigned short)random();
 return(0);
}
/******************************************************************************/
/*                      Initialize the equalizer taps.
*******************************************************************************/
int Eq_Taps_Init()
{
 int cnt;
 for(cnt=ZERO;cnt<EQ_TAP_SIZE;cnt++)
  Re_Eq_Tap[cnt]=Im_Eq_Tap[cnt]=0.0;
 Re_Eq_Tap[ZERO]=1.0;
 return(0);
}
/******************************************************************************/
/*                     Initialize the receiver register.
*******************************************************************************/
int Eq_Op_Reg_Init()
{
 int cnt,cnt1;
 for(cnt1=ZERO;cnt1<NUM_TX_STATES;cnt1++)
 {
  for(cnt=ZERO;cnt<=EQ_OP_REG_SIZE;cnt++)
   Re_Eq_Op_Reg[cnt1][cnt]=Im_Eq_Op_Reg[cnt1][cnt]=0.0;
 }
 return(0);
}
/******************************************************************************/
/*                            Initialize the VA.
*******************************************************************************/
int VA_Init()
{
 Depth=ZERO;
 Fst_Depth=Lst_Depth=NULL;
 VA_Ip_Sym_Num=VA_Op_Sym_Num= MINUSONE;
 Min_Wght_St=ZERO;
 return(0);
}
/******************************************************************************/
