/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc12type.h"
#include "pc12ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Check_Var();
 Open_Files();
 Get_Channel_Taps();
 Normalize_Channel_Taps();
 Print_Norm_Channel_Taps();
 Get_4QAM();
 Get_Trellis();
 Sim_Init();
 Get_Fade_Filter();
 return(0);
}
/******************************************************************************/
/*                        Open files for reading.
*******************************************************************************/
int Open_Files()
{
 fp1=fopen("pc12data/chan.dat","r");
 if(fp1 == NULL)
  Error_Mes(4);
 fp2=fopen("pc12data/eq.dat","w");
 fp3=fopen("pc12data/eqerr.dat","w");
 fp6=fopen("pc12data/normchan.dat","w");
 fp7=fopen("pc12data/df.dat","w");
 return(0);
}
/******************************************************************************/
/*                          Get the channel taps.
*******************************************************************************/
int Get_Channel_Taps()
{
 int cnt;
 double tap;
 cnt=ZERO;
 Chan_Energy=0.0;
 while(fscanf(fp1,"%lf",&tap) != EOF)
 {
  if(cnt == CHAN_SIZE)
   Error_Mes(5);
  Chan_Tap[cnt]=tap;
  Chan_Energy=Chan_Energy+tap*tap;
  cnt++;
 }
 if(cnt != CHAN_SIZE)
  Error_Mes(8);
 return(0);
}
/******************************************************************************/
/*                       Normalize the channel taps.
*******************************************************************************/
int Normalize_Channel_Taps()
{
 int cnt;
 if(FADE)                                                  /* Fading channel. */
 {
  for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
   Chan_Tap[cnt]=Chan_Tap[cnt]*sqrt(10.0/11.0)/sqrt(Chan_Energy);
 }
 else
 {
  for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
   Chan_Tap[cnt]=Chan_Tap[cnt]/sqrt(Chan_Energy);
 }
 return(0);
}
/******************************************************************************/
/*                    Print the normalized channel taps.
*******************************************************************************/
int Print_Norm_Channel_Taps()
{
 int cnt;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  fprintf(fp6,"%lf %lf\n",(double)cnt,Chan_Tap[cnt]);
 return(0);
}
/******************************************************************************/
