/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc12type.h"
#include "pc12ext.h"
/******************************************************************************/
/*                             Get the trellis.
*******************************************************************************/
int Get_Trellis()
{
 int p_state,p_input;
 for(p_state=ZERO;p_state<NUM_TX_STATES;p_state++)
 {
  for(p_input=ZERO;p_input<NUM_INPUTS;p_input++)
  {
   Tx_Trel_Op[p_state][p_input]=Get_Tx_Trel_Op(p_state,p_input);
   Tx_Trel_NS[p_state][p_input]=(2*p_state+p_input)%NUM_TX_STATES;
   printf("\t Tx. trellis Pre. state:%3d Input:%3d ",p_state,p_input);
   printf("Nxt. state:%3d ",Tx_Trel_NS[p_state][p_input]);
   printf("Op:%3d.\n",Tx_Trel_Op[p_state][p_input]);
  }
 }
 printf("\n");
 return(0);
}
/******************************************************************************/
/*                   Get the output. LSB maps to real part.
*******************************************************************************/
int Get_Tx_Trel_Op(p_state,p_input)
int p_state,p_input;
{
 int bit0,bit1,op0,op1,dec_op;
 bit0=p_state&1;
 bit1=(p_state/2)&1;
 op0=p_input^bit1;
 op1=p_input^bit0^bit1;
 dec_op=op0+2*op1;
 return(dec_op);
}
/******************************************************************************/
