/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern long Sym_Cnt;                                         /* Symbol count. */
extern long Valid_Sym;                                 /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
extern int Inp_Sym_Num;                         /* Sym. no. i/p to conv. enc. */
extern int Op_Sym_Num;                        /* Sym. no. o/p from conv. enc. */
extern int P_State;                              /* Present state of encoder. */
extern double Re_Sym;                          /* Re. part of current symbol. */
extern double Im_Sym;                          /* Im. part of current symbol. */
extern double Re_Rx_Reg[PRED_MEM_SIZE+ONE];            /* Stored Re. symbols. */
extern double Im_Rx_Reg[PRED_MEM_SIZE+ONE];            /* Stored Im. symbols. */
extern double Re_Map[CONSTELL_SIZE];                  /* Re. part of symbols. */
extern double Im_Map[CONSTELL_SIZE];                  /* Im. part of symbols. */
/******************************************************************************/
/*                    VARIABLES RELATED TO ERROR BUFFER.
*******************************************************************************/
extern int Err_Cnt;                               /* No. of symbols in error. */
extern int Err_Buf_Inx;                             /* Index to error buffer. */
extern int Err_Buf[ERR_BUF_SIZE];                            /* Error buffer. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double N_Val[NVALSIZE];                   /* Contains U & G rand. var. */
extern double Re_Noise;                        /* Re. part of coloured noise. */
extern double Im_Noise;                        /* Im. part of coloured noise. */
extern double Ip_Coeff;                                 /* IIR coeff. of i/p. */
extern double Coeff_Array[PRED_MEM_SIZE];               /* IIR coeff. of o/p. */
extern double Re_N_Reg[PRED_MEM_SIZE];                 /* Re. col. noise reg. */
extern double Im_N_Reg[PRED_MEM_SIZE];                 /* Im. col. noise reg. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Tx_Trel_NS[NUM_TX_STATES][NUM_INPUTS];  /* Tx. trellis:Next state. */
extern int Tx_Trel_Op[NUM_TX_STATES][NUM_INPUTS];          /* Tx. trellis:Op. */
extern int Rx_Trel_NS[MOD_NUM_RX_STATES][NUM_INPUTS];          /* Rx:Nxt. st. */
extern int Rx_Trel_Op[MOD_NUM_RX_STATES][NUM_INPUTS][PRED_SIZE];    /* Rx:Op. */
extern int Mod_State_Map[NUM_RX_STATES];   /* Mapping to modified rx. states. */
extern int Iv_Mod_State_Map[NUM_RX_STATES];               /* Inverse mapping. */
extern int Ck_Map[NUM_RX_STATES];                               /* Map check. */
extern int Mod_State;                                      /* Modified state. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE VITERBI.
*******************************************************************************/
extern int Depth;                       /* Gives the current depth of the VA. */
extern int VA_Inp;                               /* Current input to a state. */
extern int VA_P_St;                                         /* Current state. */
extern int VA_N_St;                                            /* Next state. */
extern int Min_Wght_St;                   /* State having the maximum weight. */
extern int VA_Op_Sym_Num;                    /* Symbol number released by VA. */
extern double Cur_Wght;                                     /* Cur. distance. */
extern double New_Wght;                                      /* New net wght. */
extern double Old_Wght;                                      /* Old net wght. */
extern struct Trellis *Fst_Depth,*Lst_Depth;                    /* Templates. */
/******************************************************************************/
