/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc2type.h"
#include "pc2ext.h"
/******************************************************************************/
int Simulation()
{
 for(Sym_Cnt=ZERO;Sym_Cnt<MAX_SYM;Sym_Cnt++)
 {
  Get_Symbol();
  Add_Noise();
  Receive();
 }
 return(0);
}
/******************************************************************************/
/*                        Add white Gaussian noise.
*******************************************************************************/
int Add_Noise()
{
 double erand48();
 N_Val[URADIUS]=erand48(N1_Store);
 N_Val[UTHETA]=erand48(N2_Store);
 My_Gauss(VARIANCE,N_Val);
 if(!WHITE)
  Get_Coloured_Noise();
 else
 {
  Re_Noise=N_Val[GRAND_0];
  Im_Noise=N_Val[GRAND_1];
 }
// if(Sym_Cnt < 10000)
// printf("re noise:%lf im noise:%lf\n",Re_Noise,Im_Noise);
 Re_Sym=Re_Sym+Re_Noise;
 Im_Sym=Im_Sym+Im_Noise;
 return(0);
}
/******************************************************************************/
/*                            Get coloured noise.
*******************************************************************************/
int Get_Coloured_Noise()
{
 int cnt;
 Re_Noise=Ip_Coeff*N_Val[GRAND_0];
 Im_Noise=Ip_Coeff*N_Val[GRAND_1];
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
 {
  Re_Noise=Re_Noise-Coeff_Array[cnt]*Re_N_Reg[cnt];
  Im_Noise=Im_Noise-Coeff_Array[cnt]*Im_N_Reg[cnt];
 }
 for(cnt=PRED_MEM_SIZE-ONE;cnt>ZERO;cnt--)
 {
  Re_N_Reg[cnt]=Re_N_Reg[cnt-ONE];
  Im_N_Reg[cnt]=Im_N_Reg[cnt-ONE];
 }
 Re_N_Reg[ZERO]=Re_Noise;
 Im_N_Reg[ZERO]=Im_Noise;
 return(0);
}
/******************************************************************************/
/*                         Receiver routines.
*******************************************************************************/
int Receive()
{
 Shift_Into_Rx_Reg();
 Viterbi();
 if(Sym_Cnt >= (VA_DEPTH-ONE))
  Update_Error();
 return(0);
}
/******************************************************************************/
/*           Shift the received sample into the receiver register.
*******************************************************************************/
int Shift_Into_Rx_Reg()
{
 int cnt;
 for(cnt=PRED_MEM_SIZE;cnt>ZERO;cnt--)
 {
  Re_Rx_Reg[cnt]=Re_Rx_Reg[cnt-ONE];
  Im_Rx_Reg[cnt]=Im_Rx_Reg[cnt-ONE];
 }
 Re_Rx_Reg[ZERO]=Re_Sym;
 Im_Rx_Reg[ZERO]=Im_Sym;
 return(0);
}
/******************************************************************************/
/*                     Update the symbol error count.
*******************************************************************************/
int Update_Error()
{
 int cnt;
 Valid_Sym++;
// if(Sym_Cnt < 1000)
//  printf("\t cnt:%d ebuf:%d opsym:%d\n",Sym_Cnt,Err_Buf[0],VA_Op_Sym_Num);
 if(Err_Buf[ZERO] != VA_Op_Sym_Num)
  Err_Cnt++;
 for(cnt=ZERO;cnt<=(Err_Buf_Inx-2);cnt++)
  Err_Buf[cnt]=Err_Buf[cnt+ONE];
 Err_Buf_Inx--;
 if(Err_Buf_Inx < ZERO)
  Error_Mes(15);
 return(0);
}
/******************************************************************************/
