/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/*                       FILE POINTER VARIABLES.
*******************************************************************************/
extern FILE *fp1,*fp2,*fp3,*fp4,*fp5,*fp6;                  /* File pointers. */
/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
extern long Sym_Cnt;                                         /* Symbol count. */
extern long Valid_Sym;                                 /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
extern int Inp_Sym_Num;                         /* Sym. no. i/p to conv. enc. */
extern int Op_Sym_Num;                        /* Sym. no. o/p from conv. enc. */
extern int P_State;                              /* Present state of encoder. */
extern double Re_Sym;                          /* Re. part of current symbol. */
extern double Im_Sym;                          /* Im. part of current symbol. */
extern double Re_Rx_Reg[RX_REG_SIZE];                  /* Stored Re. symbols. */
extern double Im_Rx_Reg[RX_REG_SIZE];                  /* Stored Im. symbols. */
extern double Re_Map[CONSTELL_SIZE];                  /* Re. part of symbols. */
extern double Im_Map[CONSTELL_SIZE];                  /* Im. part of symbols. */
/******************************************************************************/
/*                    VARIABLES RELATED TO ERROR BUFFER.
*******************************************************************************/
extern int Err_Cnt;                               /* No. of symbols in error. */
extern int Err_Buf_Inx;                             /* Index to error buffer. */
extern int Err_Buf[ERR_BUF_SIZE];                            /* Error buffer. */
/******************************************************************************/
/*                           CHANNEL VARIABLES.
*******************************************************************************/
extern double Chan_Energy;                                 /* Channel energy. */
extern double Re_Chan_Op;                              /* Re. channel output. */
extern double Im_Chan_Op;                              /* Im. channel output. */
extern double Re_Chan_Tap[CHAN_SIZE];                    /* Re. channel taps. */
extern double Im_Chan_Tap[CHAN_SIZE];                    /* Im. channel taps. */
extern double Re_Chan_Reg[CHAN_SIZE];                     /* Re. channel reg. */
extern double Im_Chan_Reg[CHAN_SIZE];                     /* Im. channel reg. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
extern unsigned short N1_Store[PN_SIZE];                /* Stores PNS status. */
extern unsigned short N2_Store[PN_SIZE];                /* Stores PNS status. */
extern double N_Val[NVALSIZE];                   /* Contains U & G rand. var. */
extern double Re_Noise;                        /* Re. part of coloured noise. */
extern double Im_Noise;                        /* Im. part of coloured noise. */
extern double Ip_Coeff;                                 /* IIR coeff. of i/p. */
extern double Coeff_Array[PRED_MEM_SIZE];               /* IIR coeff. of o/p. */
extern double Re_N_Reg[PRED_MEM_SIZE];                 /* Re. col. noise reg. */
extern double Im_N_Reg[PRED_MEM_SIZE];                 /* Im. col. noise reg. */
/******************************************************************************/
/*                          EQUALIZER VARIABLES.
*******************************************************************************/
extern int Eq_DD_Update_Instant;     /* Update instant of the eq. in DD mode. */
extern int Eq_Err_Buf_Inx;                /* Index to equalizer error buffer. */
extern int Eq_Err_Buf[ERR_BUF_SIZE];               /* Equalizer error buffer. */
extern double Eq_Inp_Energy;                    /* Energy of equalizer input. */
extern double Re_Eq_Err;                       /* Re. error at equalizer o/p. */
extern double Im_Eq_Err;                       /* Im. error at equalizer o/p. */
extern double Re_Eq_Op;                                 /* Re. equalizer o/p. */
extern double Im_Eq_Op;                                 /* Re. equalizer o/p. */
extern double Re_Eq_Tap[EQ_TAP_SIZE];                  /* Re. equalizer taps. */
extern double Im_Eq_Tap[EQ_TAP_SIZE];                  /* Im. equalizer taps. */
extern double Re_Eq_Reg[EQ_REG_SIZE];                   /* Re. equalizer reg. */
extern double Im_Eq_Reg[EQ_REG_SIZE];                   /* Im. equalizer reg. */
/******************************************************************************/
/*            VARIABLES RELATED TO THE LEVINSON DURBIN ALGORITHM.
*******************************************************************************/
extern int Eq_Err_Store_Inx;                        /* Eq. error store index. */
extern double Re_Eq_Err_Store[EQ_ERR_STORE_SIZE];    /* Stores re. eq. error. */
extern double Im_Eq_Err_Store[EQ_ERR_STORE_SIZE];    /* Stores im. eq. error. */
extern double Pred_Var;                         /* Prediction error variance. */
extern double Re_Pred_Coeff[NUM_PRED][PRED_SIZE];         /* Re. pred. coeff. */
extern double Im_Pred_Coeff[NUM_PRED][PRED_SIZE];         /* Im. pred. coeff. */
extern double Re_Err_AC[ERR_AC_SIZE];            /* Re. autocorr. of eq. err. */
extern double Im_Err_AC[ERR_AC_SIZE];            /* Im. autocorr. of eq. err. */
extern double Re_Eq_AC[EQ_AC_SIZE];                   /* Re. autocorr. of eq. */
extern double Im_Eq_AC[EQ_AC_SIZE];                   /* Im. autocorr. of eq. */
extern double Re_AC[PRED_SIZE];                              /* Re. autocorr. */
extern double Im_AC[PRED_SIZE];                              /* Im. autocorr. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
extern int Tx_Trel_NS[NUM_TX_STATES][NUM_INPUTS];              /* Tx:Nxt. st. */
extern int Tx_Trel_Op[NUM_TX_STATES][NUM_INPUTS];                   /* Tx:Op. */
extern int Rx_Trel_NS[MOD_NUM_RX_STATES][NUM_INPUTS];          /* Rx:Nxt. st. */
extern int Rx_Trel_Op[MOD_NUM_RX_STATES][NUM_INPUTS][PRED_SIZE];    /* Rx:Op. */
extern int Mod_State_Map[NUM_RX_STATES];   /* Mapping to modified rx. states. */
extern int Iv_Mod_State_Map[NUM_RX_STATES];               /* Inverse mapping. */
extern int Ck_Map[NUM_RX_STATES];                               /* Map check. */
extern int Mod_State;                                      /* Modified state. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE VITERBI.
*******************************************************************************/
extern int Depth;                       /* Gives the current depth of the VA. */
extern int VA_Inp;                               /* Current input to a state. */
extern int VA_P_St;                                         /* Current state. */
extern int VA_N_St;                                            /* Next state. */
extern int Min_Wght_St;                   /* State having the maximum weight. */
extern int VA_Ip_Sym_Num;                       /* Ip. symbol released by VA. */
extern int VA_Op_Sym_Num;                       /* Op. symbol released by VA. */
extern int VA_Op_Buf_Inx;                       /* Index to VA output buffer. */
extern int VA_Op_Buf[ERR_BUF_SIZE];     /* Buffer to store VA output symbols. */
extern double Cur_Wght;                                     /* Cur. distance. */
extern double New_Wght;                                      /* New net wght. */
extern double Old_Wght;                                      /* Old net wght. */
extern struct Trellis *Fst_Depth,*Lst_Depth;                    /* Templates. */
/******************************************************************************/
