/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc5type.h"
#include "pc5ext.h"
/******************************************************************************/
int Pre_Processor()
{
 Check_Var();
 Open_Files();
 Get_Channel_Taps();
 Normalize_Channel_Taps();
 Print_Norm_Channel_Taps();
 Get_4QAM();
 Get_Trellis();
 Sim_Init();
 return(0);
}
/******************************************************************************/
/*                        Open files for reading.
*******************************************************************************/
int Open_Files()
{
 fp1=fopen("pc5data/chan.dat","r");
 if(fp1 == NULL)
  Error_Mes(4);
 fp2=fopen("pc5data/eq.dat","w");
 fp3=fopen("pc5data/eqerr.dat","w");
 fp4=fopen("pc5data/eqerrac.dat","w");
 fp5=fopen("pc5data/eqac.dat","w");
 fp6=fopen("pc5data/normchan.dat","w");
 return(0);
}
/******************************************************************************/
/*                          Get the channel taps.
*******************************************************************************/
int Get_Channel_Taps()
{
 int cnt;
 double re_tap,im_tap;
 cnt=ZERO;
 Chan_Energy=0.0;
 while(fscanf(fp1,"%lf %lf",&im_tap,&re_tap) != EOF)
 {
  if(cnt == CHAN_SIZE)
   Error_Mes(5);
  Re_Chan_Tap[cnt]=re_tap;
  Im_Chan_Tap[cnt]=im_tap;
  Chan_Energy=Chan_Energy+re_tap*re_tap+im_tap*im_tap;
  cnt++;
 }
 if(cnt != CHAN_SIZE)
  Error_Mes(8);
 return(0);
}
/******************************************************************************/
/*                       Normalize the channel taps.
*******************************************************************************/
int Normalize_Channel_Taps()
{
 int cnt;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
 {
  Re_Chan_Tap[cnt]=Re_Chan_Tap[cnt]/sqrt(Chan_Energy);
  Im_Chan_Tap[cnt]=Im_Chan_Tap[cnt]/sqrt(Chan_Energy);
 }
 return(0);
}
/******************************************************************************/
/*                    Print the normalized channel taps.
*******************************************************************************/
int Print_Norm_Channel_Taps()
{
 int cnt;
 for(cnt=ZERO;cnt<CHAN_SIZE;cnt++)
  fprintf(fp6,"%lf %lf\n",Im_Chan_Tap[cnt],Re_Chan_Tap[cnt]);
 return(0);
}
/******************************************************************************/
