/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc7type.h"
#include "pc7ext.h"
/******************************************************************************/
/*                              Check variables.
*******************************************************************************/
int Check_Var()
{
 Ck_Rx_States();
 Ck_Mod_Rx_States();
 return(0);
}
/******************************************************************************/
/*          Check the number of states in the receiver trellis.
*******************************************************************************/
int Ck_Rx_States()
{
 int cnt,num_states;
 num_states=ONE;
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
  num_states=num_states*CONSTELL_SIZE;
 if(num_states != NUM_PRED_STATES)
  Error_Mes(1);
 num_states=num_states*NUM_TX_STATES;
 if(num_states != NUM_RX_STATES)
  Error_Mes(2);
 return(0);
}
/******************************************************************************/
/*       Check the modified number of states in the receiver trellis.
*******************************************************************************/
int Ck_Mod_Rx_States()
{
 int cnt,num_states;
 num_states=ONE;
 for(cnt=ZERO;cnt<PRED_SIZE;cnt++)
  num_states=num_states*NUM_INPUTS;
 if(num_states != MOD_NUM_INPUTS)
  Error_Mes(10);
 num_states=num_states*NUM_TX_STATES/NUM_INPUTS;
 if(num_states != MOD_NUM_RX_STATES)
  Error_Mes(11);
 return(0);
}
/******************************************************************************/
