/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/*                          COUNTER VARIABLES.
*******************************************************************************/
long Sym_Cnt;                                                /* Symbol count. */
long Valid_Sym;                                        /* Valid symbol count. */
/******************************************************************************/
/*                      BIT AND SYMBOL VARIABLES.
*******************************************************************************/
int Inp_Sym_Num;                                /* Sym. no. i/p to conv. enc. */
int Op_Sym_Num;                               /* Sym. no. o/p from conv. enc. */
int P_State;                                     /* Present state of encoder. */
double Re_Sym;                                 /* Re. part of current symbol. */
double Im_Sym;                                 /* Im. part of current symbol. */
double Re_Rx_Reg[PRED_MEM_SIZE+ONE];                   /* Stored Re. symbols. */
double Im_Rx_Reg[PRED_MEM_SIZE+ONE];                   /* Stored Im. symbols. */
double Re_Map[CONSTELL_SIZE];                         /* Re. part of symbols. */
double Im_Map[CONSTELL_SIZE];                         /* Im. part of symbols. */
/******************************************************************************/
/*                    VARIABLES RELATED TO ERROR BUFFER.
*******************************************************************************/
int Err_Cnt;                                      /* No. of symbols in error. */
int Err_Buf_Inx;                                    /* Index to error buffer. */
int Err_Buf[ERR_BUF_SIZE];                                   /* Error buffer. */
/******************************************************************************/
/*                       NOISE GENERATOR VARIABLES.
*******************************************************************************/
unsigned short N1_Store[PN_SIZE];                       /* Stores PNS status. */
unsigned short N2_Store[PN_SIZE];                       /* Stores PNS status. */
double N_Val[NVALSIZE];                          /* Contains U & G rand. var. */
double Re_Noise;                               /* Re. part of coloured noise. */
double Im_Noise;                               /* Im. part of coloured noise. */
double Ip_Coeff;                                        /* IIR coeff. of i/p. */
double Coeff_Array[AR_MEM_SIZE];                        /* IIR coeff. of o/p. */
double Re_N_Reg[AR_MEM_SIZE];                          /* Re. col. noise reg. */
double Im_N_Reg[AR_MEM_SIZE];                          /* Im. col. noise reg. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE TRELLIS.
*******************************************************************************/
int Tx_Trel_NS[NUM_TX_STATES][NUM_INPUTS];         /* Tx. trellis:Next state. */
int Tx_Trel_Op[NUM_TX_STATES][NUM_INPUTS];                 /* Tx. trellis:Op. */
int Rx_Trel_NS[MOD_NUM_RX_STATES][NUM_INPUTS];                 /* Rx:Nxt. st. */
int Rx_Trel_Op[MOD_NUM_RX_STATES][NUM_INPUTS][PRED_SIZE];           /* Rx:Op. */
int Mod_State_Map[NUM_RX_STATES];          /* Mapping to modified rx. states. */
int Iv_Mod_State_Map[NUM_RX_STATES];                      /* Inverse mapping. */
int Ck_Map[NUM_RX_STATES];                                      /* Map check. */
int Mod_State;                                             /* Modified state. */
/******************************************************************************/
/*            VARIABLES RELATED TO THE LEVINSON DURBIN ALGORITHM.
*******************************************************************************/
double Re_Trn_Reg[TRN_LENGTH];                           /* Stores re. error. */
double Im_Trn_Reg[TRN_LENGTH];                           /* Stores im. error. */
double Re_MF_Reg[TRN_LENGTH];                             /* MF of re. error. */
double Im_MF_Reg[TRN_LENGTH];                             /* MF of im. error. */
double Pred_Var;                                /* Prediction error variance. */
double Re_Pred_Coeff[NUM_PRED][PRED_SIZE];                /* Re. pred. coeff. */
double Im_Pred_Coeff[NUM_PRED][PRED_SIZE];                /* Im. pred. coeff. */
double Re_AC[PRED_SIZE];                                     /* Re. autocorr. */
double Im_AC[PRED_SIZE];                                     /* Im. autocorr. */
/******************************************************************************/
/*                    VARIABLES RELATED TO THE VITERBI.
*******************************************************************************/
int Depth;                              /* Gives the current depth of the VA. */
int VA_Inp;                                      /* Current input to a state. */
int VA_P_St;                                                /* Current state. */
int VA_N_St;                                                   /* Next state. */
int Min_Wght_St;                          /* State having the maximum weight. */
int VA_Op_Sym_Num;                           /* Symbol number released by VA. */
double Cur_Wght;                                            /* Cur. distance. */
double New_Wght;                                             /* New net wght. */
double Old_Wght;                                             /* Old net wght. */
struct Trellis *Fst_Depth,*Lst_Depth;                           /* Templates. */
/******************************************************************************/
