/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc9type.h"
#include "pc9ext.h"
/******************************************************************************/
/*                   Initialize simulation variables.
*******************************************************************************/
int Sim_Init()
{
 Enc_Init();
 Err_Buf_Init();
 Error_Init();
 Noise_Gen_Init();
 Noise_Coeff_Init();
 Noise_Reg_Init();
 Rx_Reg_Init();
 VA_Init();
 return(0);
}
/******************************************************************************/
/*                         Initialize the encoder.
*******************************************************************************/
int Enc_Init()
{
 P_State=ZERO;
 return(0);
}
/******************************************************************************/
/*                      Initialize the error buffer.
*******************************************************************************/
int Err_Buf_Init()
{
 Err_Buf_Inx=ZERO;
 return(0);
}
/******************************************************************************/
/*                       Initialize the error.
*******************************************************************************/
int Error_Init()
{
 Err_Cnt=ZERO;
 Valid_Sym=ZERO;
 return(0);
}
/******************************************************************************/
/*                     Initialize the noise generator.
*******************************************************************************/
int Noise_Gen_Init()
{
 long int random(void);
 N1_Store[0]=(unsigned short)random();
 N1_Store[1]=(unsigned short)random();
 N1_Store[2]=(unsigned short)random();
 N2_Store[0]=(unsigned short)random();
 N2_Store[1]=(unsigned short)random();
 N2_Store[2]=(unsigned short)random();
 return(0);
}
/******************************************************************************/
/*            Initialize the coloured noise generator coefficients.
*******************************************************************************/
int Noise_Coeff_Init()
{
 double tmp;
 tmp= 0.8;
 Ip_Coeff=sqrt(1.0-tmp*tmp);
 Coeff_Array[0]= tmp;
 return(0);
}
/******************************************************************************/
/*                       Initialize the noise register.
*******************************************************************************/
int Noise_Reg_Init()
{
 int cnt;
 for(cnt=ZERO;cnt<PRED_MEM_SIZE;cnt++)
  Re_N_Reg[cnt]=Im_N_Reg[cnt]=0.0;
 return(0);
}
/******************************************************************************/
/*                     Initialize the receiver register.
*******************************************************************************/
int Rx_Reg_Init()
{
 int cnt;
 for(cnt=ZERO;cnt<=PRED_MEM_SIZE;cnt++)
  Re_Rx_Reg[cnt]=Im_Rx_Reg[cnt]=0.0;
 return(0);
}
/******************************************************************************/
/*                            Initialize the VA.
*******************************************************************************/
int VA_Init()
{
 Depth=ZERO;
 Fst_Depth=Lst_Depth=NULL;
 VA_Op_Sym_Num= MINUSONE;
 Min_Wght_St=ZERO;
 return(0);
}
/******************************************************************************/
