/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
#include "pc9type.h"
#include "pc9ext.h"
/******************************************************************************/
/*                           Training procedures.
*******************************************************************************/
int Trn_Proc()
{
 Re_Trn_Reg[Sym_Cnt]=Re_Noise;
 Im_Trn_Reg[Sym_Cnt]=Im_Noise;
 Re_MF_Reg[TRN_LENGTH-ONE-Sym_Cnt]=  Re_Noise;
 Im_MF_Reg[TRN_LENGTH-ONE-Sym_Cnt]= -Im_Noise;
 if(Sym_Cnt == (TRN_LENGTH-ONE))
 {
  Get_Pred_Coeff();
  Levinson_Durbin();
 }
 return(0);
}
/******************************************************************************/
/*                 Get the prediction filter coefficients.
*******************************************************************************/
int Get_Pred_Coeff()
{
 double *reip1,*imip1,*reip2,*imip2;
 double reop[ERR_AC_SIZE],imop[ERR_AC_SIZE];
 reip1=Re_Trn_Reg;
 imip1=Im_Trn_Reg;
 reip2=Re_MF_Reg;
 imip2=Im_MF_Reg;
 Convolve(reip1,imip1,reip2,imip2,reop,imop,TRN_LENGTH,TRN_LENGTH);
 Weight_AC(reop,imop);
 Copy_AC(reop,imop);
 return(0);
}
/******************************************************************************/
/*                        Weight the autocorrelation.
*******************************************************************************/
int Weight_AC(reop,imop)
double reop[],imop[];
{
 int cnt;
 for(cnt=ZERO;cnt<ERR_AC_SIZE;cnt++)
 {
  if(cnt < TRN_LENGTH)
  {
   reop[cnt]=reop[cnt]/(double)(cnt+ONE);
   imop[cnt]=imop[cnt]/(double)(cnt+ONE);
  }
  else
  {
   reop[cnt]=reop[cnt]/(double)(ERR_AC_SIZE-cnt);
   imop[cnt]=imop[cnt]/(double)(ERR_AC_SIZE-cnt);
  }
 }
 return(0);
}
/******************************************************************************/
/*  Copy the equalizer error autocorrelation into the autocorrelation array.
*******************************************************************************/
int Copy_AC(reop,imop)
double reop[],imop[];
{
 int cnt;
 for(cnt=ZERO;cnt<PRED_SIZE;cnt++)
 {
  Re_AC[cnt]=reop[TRN_LENGTH-ONE+cnt];
  Im_AC[cnt]=imop[TRN_LENGTH-ONE+cnt];
  printf("\t Index:%d reac:%lf imac:%lf\n",cnt,Re_AC[cnt],Im_AC[cnt]);
 }
 return(0);
}
/******************************************************************************/
