/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/* Program to plot the average symbol error rate for a TCM scheme in
   coloured noise.
*******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
#define COEF 0.8       /* Positive corresponds to highpass, negative lowpass. */
#define MAX_CNT 18                                 /* Max. no. of iterations. */
#define STEP_SIZE (0.05)     /* Amount by which variance needs to be changed. */
#define ZERO 0                                                 /* A constant. */
/******************************************************************************/
double Variance;       /* Noise variance of in-phase or quadrature component. */
double Snr;                                         /* Signal-to-noise ratio. */
double Ser;                                             /* Symbol-error-rate. */
FILE *fp1;                                                   /* File pointer. */
/******************************************************************************/
main()
{
 Open_File();
 Print_SER();
}
/******************************************************************************/
/*                          Open file for writing.
*******************************************************************************/
int Open_File()
{
 fp1=fopen("cvacoded.dat","w");
 return(0);
}
/******************************************************************************/
/*                            Symbol error rate.
*******************************************************************************/
int Print_SER()
{
 int cnt;
 double numer,denom,arg;
 Variance=0.1;
 numer=400.0;
 for(cnt=ZERO;cnt<MAX_CNT;cnt++)
 {
  denom=32.0*Variance*(5.0+4.0*COEF+4.0*COEF*COEF);
  arg=numer/denom;
  arg=sqrt(arg);
  Ser=erfc(arg)/6.0;
  Snr=10.0*log10(2.0/(2.0*Variance));
  fprintf(fp1,"%14.10lf %14.10lf\n",Snr,Ser);
  Variance=Variance+STEP_SIZE;
 }
 return(0);
}
/******************************************************************************/
