/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/* Program to plot the lower bound on the average symbol error rate for a
   TCM scheme in coloured noise. The lower bound is based on only the
   squared minimum distance.
*******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
#define COEF 0.8       /* Positive corresponds to highpass, negative lowpass. */
#define MAX_CNT 24                                 /* Max. no. of iterations. */
#define STEP_SIZE (0.2)      /* Amount by which variance needs to be changed. */
#define ZERO 0                                                 /* A constant. */
/******************************************************************************/
double Variance;       /* Noise variance of in-phase or quadrature component. */
double Snr;                                         /* Signal-to-noise ratio. */
double Ser;                                             /* Symbol-error-rate. */
FILE *fp1;                                                   /* File pointer. */
/******************************************************************************/
main()
{
 Open_File();
 Print_SER();
}
/******************************************************************************/
/*                          Open file for writing.
*******************************************************************************/
int Open_File()
{
 fp1=fopen("pvacoded.dat","w");
 return(0);
}
/******************************************************************************/
/*                            Symbol error rate.
*******************************************************************************/
int Print_SER()
{
 int cnt;
 double numer,denom,arg;
 Variance=1.5;
 numer=12.0*(1.0+COEF*COEF)+4.0*(1.0+COEF)*(1.0+COEF);
 numer=numer+4.0*(1.0+COEF)*(1.0+COEF);
 for(cnt=ZERO;cnt<MAX_CNT;cnt++)
 {
  denom=8.0*Variance*(1.0-COEF*COEF);
  arg=numer/denom;
  arg=sqrt(arg);
  Ser=erfc(arg)/8.0;
  Snr=10.0*log10(2.0/(2.0*Variance));
  fprintf(fp1,"%16.12lf %16.12lf\n",Snr,Ser);
  Variance=Variance+STEP_SIZE;
 }
 return(0);
}
/******************************************************************************/
