/******************************************************************************/
/*   Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.  */
/*   All Rights Reserved.                                                     */
/******************************************************************************/
/******************************************************************************/
/* Program to plot the lower bound on the average symbol error rate for a
   TCM scheme in coloured noise. The lower bound is based on the first two
   squared minimum distances.
*******************************************************************************/
#include <stdio.h>
#include <math.h>
/******************************************************************************/
#define COEF 0.8       /* Positive corresponds to highpass, negative lowpass. */
#define MAX_CNT 18                                 /* Max. no. of iterations. */
#define STEP_SIZE (0.2)      /* Amount by which variance needs to be changed. */
#define ZERO 0                                                 /* A constant. */
/******************************************************************************/
double Variance;       /* Noise variance of in-phase or quadrature component. */
double Snr;                                         /* Signal-to-noise ratio. */
double Ser;                                             /* Symbol-error-rate. */
FILE *fp1;                                                   /* File pointer. */
/******************************************************************************/
main()
{
 Open_File();
 Print_SER();
}
/******************************************************************************/
/*                          Open file for writing.
*******************************************************************************/
int Open_File()
{
 fp1=fopen("pvacoded1.dat","w");
 return(0);
}
/******************************************************************************/
/*                            Symbol error rate.
*******************************************************************************/
int Print_SER()
{
 int cnt;
 double numer1,numer2,denom,arg1,arg2;
 Variance=1.0;
 numer1=12.0*(1.0+COEF*COEF)+8.0*(1.0+COEF)*(1.0+COEF);
 numer2=12.0*(1.0+COEF*COEF)+12.0*(1.0+COEF)*(1.0+COEF);
 for(cnt=ZERO;cnt<MAX_CNT;cnt++)
 {
  denom=16.0*Variance*(1.0-COEF*COEF);
  arg1=numer1/denom;
  arg2=numer2/denom;
  arg1=sqrt(arg1);
  arg2=sqrt(arg2);
  Ser=erfc(arg1)/8.0;
  Ser=Ser+2.0*erfc(arg2)/10.0;
  Snr=10.0*log10(2.0/(2.0*Variance));
  fprintf(fp1,"%14.10lf %14.10lf\n",Snr,Ser);
  Variance=Variance+STEP_SIZE;
 }
 return(0);
}
/******************************************************************************/
