#*******************************************************************************
#    Copyright (C) 2001 K. Vasudevan. Indian Institute of Technology Kanpur.
#    All Rights Reserved.
#*******************************************************************************
# Plot of the symbol error rates for predictive VA, regular VA
# and MLSE.
#*******************************************************************************
#*******************************************************************************
# Gnuplot file. To plot the graph run gnuplot and at the gnuplot prompt
# type: load "ser4qam.gp"<RETURN>
# If you want the output on the screen, comment the following two lines:
# set term postscript eps color 22
# set output "ser4qam.eps"
# Comment lines begin with a #.
# For help on gnuplot, run gnuplot and type the following at the gnuplot
# prompt: help
#*******************************************************************************
#set term postscript eps color 22
set key box
set format y "%2.1e"
#set output "ser4qam.eps"
set logscale y
set xlabel "SNR (dB)"
set ylabel "Symbol error rate"
plot "../pc3/pc3data/pc3serdd1.dat" t\
     "Predictive VA, estimated decisions, equalizer autocorrelation"\
      w lines lt 1 lw 3,\
     "../pc3/pc3data/pc3erracdd1.dat" t\
     "Predictive VA, estimated decisions, equalizer error autocorrelation"\
      w lines lt 2 lw 3,\
     "../pc4/pc4data/pc4serdd1.dat" t "Regular VA, estimated decisions"\
      w lines lt 3 lw 3,\
     "../nmlse2/n2data/nmlse2_vadelay10.dat" t "Ideal MLSE"\
      w lines lt 4 lw 3
